' {$STAMP BS1}
' {$PBASIC 1.0}

' MuBox Temp measure and fan speed controller  #1  230GHz/345GHz
'==== Output/Input pin setup Recevier Compartment Fan Controller
DIRS = %11111011       'Set Pins 0,1,3,4,5,6 & 7 to output
'
'Maxim 187BCPA+  12 bit ADC serial data
'       -CS Pin 0, Clk 1, Data 2
'       Vref internal 4.096
'       1000 0000 0000 2.048
'       1 bit = .0010 volts
'
'Maxim 5352BCUA+ 12 bit DAC serial data
'       -CS Pin 3, Clk 4, Data 5
'       Vref 2.5  ext from Max187 and Poteniometer Unipolar setup
'       1 bit = .001221 volts
'
'Burrr Brown OPA548T  OP Amp for output
'
'
'==== Variables
SYMBOL TempIn = W1       'Uses b2,b3
SYMBOL TempAve = W4      'Uses b8,b9
SYMBOL TempOut = W5      'Temp rolling average
SYMBOL Dog = B4          'For loop counter Temp measure
'
'==== AD (MAX 187) Setup
SYMBOL ClkIn = 1         ' ClkIn = Clock to AD use "Pulsout ClkIn,N" Width =N*10us
SYMBOL CsIn = 0          ' CsIn = AD Chip select
SYMBOL DatIn = PIN2      ' Data In pin
HIGH CsIn                ' CS set high "standby" go low and stay to convert and read
LOW ClkIn                ' Clk set low  to clk data pulseout bit on each - edge
'
'==== DA (MAX5352) Setup
SYMBOL CsOut = 3         'DAC Chip Select
SYMBOL ClkOut = 4        'DAC Clk
SYMBOL Data = PIN5       'Bit shift to Var DatOut
SYMBOL TOut = W0         '0 Volts out variable, Uses b0,b1
TempOut = 10500          '10500 Jump Start average and test Fan; should be high enough fan can be heard
'
'==== Status LED's Initalization
Setup:
HIGH 6
HIGH 7

'===Start up Test Blink
PULSOUT 6, 60000    'Blue LED
PULSOUT 7, 60000    'Red LED
PAUSE 1000
'
'==== Main
Main:
'==== Get Temp from MAX187 and LM35DT.  "Debug" only dispaly value while testing
'TempMeas:
 LOW CsIn                   'Set Chip Select AD low, Initiates conversion
  PAUSE  500                 'Time for AD to setup
  TempIn = 0
    SetIn:                      'Data out line goes high when ready to transmit SO
      IF DatIn = 0 THEN SetIn   'When ready continue
        FOR Dog  = 1 TO 12         'Starts Read of 12 bits serial
          TempIn = TempIn * 2      'Shift Left
          PULSOUT ClkIn,2          'Clk pulse 10us
          TempIn = TempIn + DatIn  'add bit 1 less significant
        NEXT                       'Loop back to "For" for next bit or end after 12
        'DEBUG TempIn
        'TempIn = 242           '242 is minimum start on Temp 24.2 C with up scaling of 1970
                                '291 is max output Temp 29.1 C This is from lab testing @ Caltech
      TempIn = TempIn*10-30     '20 Degrees C becomes 2200 this helps reduce round off errors
      'DEBUG TempIn              '30 is error corection for #1 room temp actual Temp sensor & ADC
                                'When you raise OR lower this TO calibrate temp reading THEN adjust scaling number correspondingly in the opposite direction
      'TempIn = 2910             'Integer math AND all numbers round down 27.9 = 27.0
      TempIn = TempIn/5*9+3200  'Convert to F
    PULSOUT ClkIn,2             'One additional Pulse to check that register is clear
  HIGH CsIn                     'AD back to Standby
  LOW ClkIn                     'Ditto
  'DEBUG TempIn
  '
'==== Scale Up or Down
  TempIn=TempIn + 1970          'Making this number larger will start fan at lower temp, adjust equation for "TempAve" equally below in Averaging section
  'DEBUG TempIn
'
'==== Averageing
      TempOut = TempOut/9*8           '89% of old Temp
      TempOut = TempIn/9+TempOut      'Plus 11% of new = Rolling Average
                                      'Can't go higher, Divide by 10 or more and integer round off defeats averaging
                                      'Stablizes the circuit more then the box.
      TempAve=TempOut-1970            'Subtracted number must be the same as the scale up number used in Scale Up or Down Section of code above
      'DEBUG TempAve
      'TempOut = TempIn              'Testing Purposes
'
'==== OutPut Value to DAC MAX5253 and Exponetial Curve (Simple formula)
  'TempOut = 9451                  '10339 keeps fan @ max V of 12.5 to be safe. Rated for 13 V
                                   '10340 goes to 12.83 V, with V supply 15 this is probable Max Vout
  'DEBUG TempOut                    'for the OPA 548
  IF TempOut > 10339 THEN Fan1     'Max Fan @ ? Temp = 28.1C
  IF TempOut < 9458 THEN  Fan2     'If not at least 4.5 V Fan Off
     TOut = TempOut/10-850
     TOut = TOut*TOut/77+TOut*12+284        'Simplified Exponentioal Curve
  GOTO Cool
Fan1:
   TOut = 7800                     'Max DAC Output 1111111111110 = 8190 TempOut 10400 = 8188
   GOTO Cool                       '7800 is ~12.6 V & ~310mA Fan  350mA Entire unit
Fan2:                              'Just detuning slightly for relaibility @ altitude.
   TOut = 0                        'The fans are rated for 13.2 V @ sealevel
Cool:
  'TOut = 2800   'Set OpAmp gain here FOR VFan = 4.5V 2800
  'TOut = 5460   'Set here VRef = 2.50V, DAC Vref input @ min Impedance 5460
  'TOut = 8000   'Check VOut Max  12.6V Min  13.0V Max 8000
                                  'Shift 1 bit left MSB-1 now TOut = 000XXXXXXXXXXXX0
                                  'This formats in the control bits C2,C1,C0, DATA, S0
                                  'The Max DAC takes in a 16 bit word (12 data 4 control)
  LOW CsOut                       'DAC Chip Select ON
  'DEBUG TOut, CR, CR        'Prints variable and then one empty line
      FOR Dog = 0 TO 15      'Start Loop to send entire word
        Data = BIT15
        PULSOUT ClkOut, 2    'Clock pulse - shift in bit
        LET TOut = TOut*2    'Shift 1 bit left MSB-1 now msb
      NEXT                   'Until all 15 bits repeat "For" loop
    HIGH CsOut               'Deselect DAC'
    LOW ClkOut               'Ditto  DAC hold
   PAUSE 10000                '10000 = 12 second cycle time for entire Cycle of program
  PULSOUT 6, 25000
  IF TempOut > 10310 THEN Warn    'Red LED blink near V limit
GOTO Main
Warn:
PULSOUT 7, 65000    '10310 = ~27.8C and ~12.4 V to Fan
GOTO Main